#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK6x48x48TT6x3x1_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=6, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const double *stM = A + (((lda) << 3)+((lda) << 2));
   const double *stN = B + 96;
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 2
   const int incAm = ((((((lda) << 2)+((lda) << 1)) - 48) << 1)), incAn = -(((lda) << 3)+((lda) << 2));
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 6)+((ldb) << 5));
   #define incBn 6
   #define incCm 12
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 12;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      pfA += lda;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      rA4 = *pA4;
      rC0_0 = rA0 * rB0;
      rA5 = *pA5;
      rC1_0 = rA1 * rB0;
      rB1 = pB0[2];
      rC2_0 = rA2 * rB0;
      rB2 = pB0[4];
      rC3_0 = rA3 * rB0;
      rC4_0 = rA4 * rB0;
      rC5_0 = rA5 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC4_1 = rA4 * rB1;
      rC5_1 = rA5 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC4_2 = rA4 * rB2;
      rC5_2 = rA5 * rB2;
      pB0 += incBk;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      pA4 += incAk;
      pA5 += incAk;
/*
 *    Unpeeled K iterations
 */
      for (k=47; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rC0_0 += rA0 * rB0;
         rA5 = *pA5;
         rC1_0 += rA1 * rB0;
         rB1 = pB0[2];
         rC2_0 += rA2 * rB0;
         rB2 = pB0[4];
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC5_2 += rA5 * rB2;
         pB0 += incBk;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
      }
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC1_0 *= rB0;
      rC1_1 *= rB0;
      rC1_2 *= rB0;
      rC2_0 *= rB0;
      rC2_1 *= rB0;
      rC2_2 *= rB0;
      rC3_0 *= rB0;
      rC3_1 *= rB0;
      rC3_2 *= rB0;
      rC4_0 *= rB0;
      rC4_1 *= rB0;
      rC4_2 *= rB0;
      rC5_0 *= rB0;
      rC5_1 *= rB0;
      rC5_2 *= rB0;
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      pC0[8] = rC4_0;
      pC0[10] = rC5_0;
      *pC1 = rC0_1;
      pC1[2] = rC1_1;
      pC1[4] = rC2_1;
      pC1[6] = rC3_1;
      pC1[8] = rC4_1;
      pC1[10] = rC5_1;
      *pC2 = rC0_2;
      pC2[2] = rC1_2;
      pC2[4] = rC2_2;
      pC2[6] = rC3_2;
      pC2[8] = rC4_2;
      pC2[10] = rC5_2;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pA4 += incAm;
      pA5 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK48x48x48TT0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=7, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (84*(lda));
   const double *stN = B + 96;
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 2
   const int incAm = ((((7*(lda)) - 48) << 1)), incAn = -(84*(lda));
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 6)+((ldb) << 5));
   #define incBn 6
   #define incCm 14
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 84;
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1)), *pA6=pA5+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      pfA += lda;
      do /* M-loop */
      {
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rC0_0 = rA0 * rB0;
         rA5 = *pA5;
         rC1_0 = rA1 * rB0;
         rA6 = *pA6;
         rC2_0 = rA2 * rB0;
         rB1 = pB0[2];
         rC3_0 = rA3 * rB0;
         rB2 = pB0[4];
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rC6_0 = rA6 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC5_1 = rA5 * rB1;
         rC6_1 = rA6 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rC4_2 = rA4 * rB2;
         rC5_2 = rA5 * rB2;
         rC6_2 = rA6 * rB2;
         pB0 += incBk;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pA6 += incAk;
/*
 *       Unpeeled K iterations
 */
         for (k=47; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rA3 = *pA3;
            rA4 = *pA4;
            rC0_0 += rA0 * rB0;
            rA5 = *pA5;
            rC1_0 += rA1 * rB0;
            rA6 = *pA6;
            rC2_0 += rA2 * rB0;
            rB1 = pB0[2];
            rC3_0 += rA3 * rB0;
            rB2 = pB0[4];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            pB0 += incBk;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
            pA6 += incAk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC3_2 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         rC4_2 *= rB0;
         rC5_0 *= rB0;
         rC5_1 *= rB0;
         rC5_2 *= rB0;
         rC6_0 *= rB0;
         rC6_1 *= rB0;
         rC6_2 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0[12] = rC6_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC1[4] = rC2_1;
         pC1[6] = rC3_1;
         pC1[8] = rC4_1;
         pC1[10] = rC5_1;
         pC1[12] = rC6_1;
         *pC2 = rC0_2;
         pC2[2] = rC1_2;
         pC2[4] = rC2_2;
         pC2[6] = rC3_2;
         pC2[8] = rC4_2;
         pC2[10] = rC5_2;
         pC2[12] = rC6_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pA6 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pA6 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_zJIK6x48x48TT6x3x1_aX_b0(6, 48, 48, alpha, ca + (84*(lda)), lda, cb, ldb, beta, cc + 84, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
