#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x48x48TN1x3x1_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=1, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2304;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 144;
   #define incCm 2
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2;
   register double rC0_0, rC0_1, rC0_2;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         for (k=48; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[48];
            rB2 = pB0[96];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x48x48TN48x48x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=48, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=7, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/7)*7;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 4));
   const double *stN = B + 2304;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*7*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 288, incAn = -(((Mb) << 5)+((Mb) << 4));
   #define incBk 1
   const int incBm = -48, incBn = 144;
   #define incCm 14
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            ATL_pfl1R(pfA+ATL_L1LS);
            pfA += incPFA;
            rC0_0 = *pC0;
            rC1_0 = pC0[2];
            rC2_0 = pC0[4];
            rC3_0 = pC0[6];
            rC4_0 = pC0[8];
            rC5_0 = pC0[10];
            rC6_0 = pC0[12];
            rC0_1 = *pC1;
            rC1_1 = pC1[2];
            rC2_1 = pC1[4];
            rC3_1 = pC1[6];
            rC4_1 = pC1[8];
            rC5_1 = pC1[10];
            rC6_1 = pC1[12];
            rC0_2 = *pC2;
            rC1_2 = pC2[2];
            rC2_2 = pC2[4];
            rC3_2 = pC2[6];
            rC4_2 = pC2[8];
            rC5_2 = pC2[10];
            rC6_2 = pC2[12];
            for (k=48; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[48];
               rA2 = pA0[96];
               rA3 = pA0[144];
               rA4 = pA0[192];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[240];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[288];
               rC2_0 += rA2 * rB0;
               rB1 = pB0[48];
               rC3_0 += rA3 * rB0;
               rB2 = pB0[96];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC6_1 += rA6 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rC6_2 += rA6 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            pC0[12] = rC6_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            pC1[8] = rC4_1;
            pC1[10] = rC5_1;
            pC1[12] = rC6_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            pC2[8] = rC4_2;
            pC2[10] = rC5_2;
            pC2[12] = rC6_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x48x48TN1x3x1_a1_b1(k, 48, 48, alpha, ca + (((Mb) << 5)+((Mb) << 4)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANM
#define ATL_zpMBmm_b1 ATL_zgpMBmm_b1
#endif

void ATL_zJIK0x48x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x48x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x48x48TN48x48x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpMBmm_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK0x48x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK0x48x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK0x48x48TN48x48x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK0x48x48TN48x48x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
